function Logger(tabl, name)
	--some magic
	if type(tabl) == "table" then
		table.sort(tabl)
		for a,b in pairs (tabl) do
			log ("a: " .. a .. " b: " .. b)
		end
		log (name .. " was table " .. serpent.line(tabl) )
	else 
		if tabl then
			log (name .. " is not table: " .. tabl)
		end
	end
end

function GoingTo(Position, Direction, Speed)
	-- let's go
	Logger(Position, "Position")
	Logger(Direction, "Direction")
	Logger(Speed , "Speed")
	

	if Position and Direction and Speed then
		table.sort(Position)
		local Position = {x=(Position.x or Position[1] or 0), y=(Position.y or Position[2] or 0)}
		local NextPosition = DirectionToNextCoordinate(Position, Direction, Speed)
		Logger(NextPosition, "NextPosition")
		return NextPosition
	else	
		return nil
	end
end

function DirectionToNextCoordinate(Position, Direction, Speed)
	local Direction = Direction
	local Position = Position
	
	if Position and Direction and Speed then
		if Direction == 0 then
			Position = {x=Position.x,y=Position.y+Speed}
		elseif Direction == 0.25 then
			Position = {x=Position.x+Speed,y=Position.y}
		elseif Direction == 0.5 then
			Position = {x=Position.x,y=Position.y-Speed}
		elseif Direction == 0.75 then
			Position = {x=Position.x-Speed,y=Position.y}
		else
			Logger(tabl, name)
			Position = {x=Position.x,y=Position.y}
		end
		Logger(Position, "next Position")
		return Position
	else
		log( "Position: " .. Position .. " Direction: " .. Direction .. "Speed: " .. Speed)
		return nil
	end
end

function findArrow(position)
	local arrowEntities -- accumulators for the first time
	local position = position
	
	--arrowEntities = game.surfaces[1].find_entities_filtered{type = "accumulator", area = GetBoundingBox(position, 3)}
	local t1 = {}
	local t2 = {}
	
	t1 = game.surfaces[1].find_entities_filtered{type = "accumulator", area = GetBoundingCross(position, 3.5,0.5)}
	t2 = game.surfaces[1].find_entities_filtered{type = "accumulator", area = GetBoundingCross(position, 0.5,3.5)}
	
	arrowEntities = tableMerge(t1, t2)
	
	if #arrowEntities > 0 then
		return FindNearestEntity(position, arrowEntities)
	else
		return nil
	end
end

function PositionsToDirection(position1, position2, lastdirection) --the second is for arrowPosition
	local p1 = {x=position1.x, y=position1.y} or {x=position1[1], y=position1[2]}
	local p2 = {x=position2.x, y=position2.y} or {x=position2[1], y=position2[2]}
	
	local direction = lastdirection
	
	if math.abs(p2.x-p1.x) > math.abs(p2.y-p1.y) then -- horizontal movement
		if  p2.x > p1.x then 
			direction = 0.75 -- going left 
		else
			direction = 0.25 -- going right
		end
	elseif math.abs(p2.x-p1.x) < math.abs(p2.y-p1.y) then -- vertical movement
		if  p2.y > p1.y then 
			direction = 0.5 -- going down 
		else
			direction = 0 -- going up
		end
	else -- the same distances
		return direction --do nothing
	end
	return direction
end

----- GetBoundingBox
function GetBoundingBox(position, radius)
	local posx = position[1] or position.x
	local posy = position[2] or position.y
	return {{posx - radius, posy - radius}, {posx + radius, posy + radius}}
end

function GetBoundingCross(position, radius1, radius2)
	local posx = position[1] or position.x
	local posy = position[2] or position.y
	
	return {{posx - radius1, posy - radius2}, {posx + radius1, posy + radius2}}
end

----- FindNearestEntity
function FindNearestEntity(baseEntPos, entList)
	-- baseEntPos is entity or position!
	local entity = baseEntPos
	local position = entity.position or baseEntPos
	
	local closestEntity = false
	local minDist = math.huge
	
	for _, entity in pairs(entList) do
		local dPos = vector.subtract(position, entity.position)
		local dist = vector.length(dPos)
		if dist < minDist then
			closestEntity = entity
			minDist = dist
		end
	end
	
	return closestEntity
end

function tableMerge(t1, t2)
    for k,v in pairs(t2) do
        if type(v) == "table" then
            if type(t1[k] or false) == "table" then
                tableMerge(t1[k] or {}, t2[k] or {})
            else
                t1[k] = v
            end
        else
            t1[k] = v
        end
    end
    return t1
end


---------------------------------


function DeltaposToOrientation(dPos)
	if dPos.x == 0 then
		if dPos.y > 0 then
			return 0.5
		else
			return 0
		end
	elseif dPos.x > 0 then
		return (math.atan(dPos.y / dPos.x) / (2 * math.pi) + 0.25)
	else
		return (math.atan(dPos.y / dPos.x) / (2 * math.pi) + 0.75)
	end
end

function GetOccupiedSlots(inventory)
	local slotsOccupied = 0	
	for itemName, count in pairs(inventory.get_contents()) do
		slotsOccupied = slotsOccupied + math.ceil(count / game.item_prototypes[itemName].stack_size)
	end
	return slotsOccupied
end

vector = {
	add = function(p1, p2)
		if not p2.x then
			return {x = p1.x + p2[1], y = p1.y + p2[2]}
		end
		return {x = p1.x + p2.x, y = p1.y + p2.y}
	end,

	subtract = function(position1, position2)
		local p1 = {x=position1.x, y=position1.y} or {x=position1[1], y=position1[2]}
		local p2 = {x=position2.x, y=position2.y} or {x=position2[1], y=position2[2]}
		return {x = p1.x - p2.x, y = p1.y - p2.y}
	end,
	
	mul = function(p1, c)
		return {x = p1.x * c, y = p1.y * c}
	end,
	
	div = function(p1, c)
		return {x = p1.x / c, y = p1.y / c}
	end,
	
	dist = function(p1, p2)
		--game.players[1].print("dist")
		return vector.length(vector.subtract(p1, p2))
	end,
	
	distsq = function(p1, p2)
		--game.players[1].print("distsq")
		return vector.lengthsq(vector.subtract(p1, p2))
	end,
	
	length = function(vector)
		return math.sqrt((vector.x * vector.x) + (vector.y * vector.y))
	end,
	
	lengthsq = function(vector)
		return (vector.x * vector.x) + (vector.y * vector.y)
	end,
	
	normalized = function(vector)
		local length = vector.length(vector)
		return {x = vector.x / length, y = vector.y / length}
	end,
}