--require("utilities")
require("routine")
require("box-utilities")

-- ==================================================
-- ================== onTickHandler =================
-- ==================================================
function onTickHandler(event)
	if global.runOnce then runOnce(event) end -- reset recepies and techs once
	if #global.Boxes > 0 then
		for _, box in pairs(global.Boxes) do
			--BoxLogic(box, event)
			main(box, event)
		end 
	end
end

function main(box, event)
	--local directions = { north = 0, west = 1, south = 2, east = 3} -- not nice
	local directions = { north = 0, east = 0.25, south = 0.5, west = 0.75}
	local mustWait = box.mustWait
	local entity = box.entity
	local position = entity.position
	local lastDirection = box.direction
	local canGo = true
	
	if mustWait then
		if mustWait > 0 then 
			box.mustWait = mustWait - 1
			--game.players[1].print("Mustwait = " .. mustWait )
			return
		else
			--game.players[1].print("Sorry, but Mustwait = " .. mustWait )
		end
	end
	
	--if box.direction == nil then
		local arrow = findArrow(position) -- entity
		if arrow == nil and box.direction == nil then return end -- there is nothing to do
		
		if arrow then
			
			game.players[1].print("arrow exist!")
			box.direction = PositionsToDirection(position, arrow.position, box.direction)
			if  not (lastDirection == box.direction) then
				box.mustWait = 2*60 + box.mustWait
				game.players[1].print("Mustwait now is " .. box.mustWait )
				game.players[1].print("Msg1! Sorry, directions was  " .. lastDirection .. " and " .. box.direction)
				canGo = false
				else
				game.players[1].print("Msg2! Sorry, directions was  " .. lastDirection .. " and " .. box.direction)
			end
		end	
			-- return direction or nil
		--return
	--end		
	
	if box.direction == nil then return end
	
	--teleport here
	local newPosition = GoingTo(position, box.direction, box.speed) -- position
		Logger(newPosition, "newPosition")
	if newPosition and canGo then
		box.entity.teleport({newPosition.x, newPosition.y})
		--box.position = newPosition
	end
	--
	
end

-- =============================================
-- ================== BoxLogic =================
-- =============================================
function BoxLogic(box, event)
	
	local entity = box.entity
	local position = entity.position
	local text = ""
	
-- ERROR IS HERE ====================
	local targetEntity = followTo(entity) or nil -- we got the target
	if targetEntity then 
		box.targetEntity = targetEntity 
	else return
	end
	
	box.targetPosition = box.targetEntity.position or {x=0, y=0}
	
	local delta = {x=0, y=0}
	
	
	if box.delta.x == 0 or box.delta.y == 0 then
		delta = {x=position.x - box.targetPosition.x, y=position.y - box.targetPosition.y}
	end
	
	
	if math.abs(delta.x) - 1.5 > math.abs(delta.y) then	
		box.delta.y = 0 
		box.delta.x = delta.x
	end
	if math.abs(delta.y) - 1.5 > math.abs(delta.x) then
		box.delta.x = 0 
		box.delta.y = delta.y
	end
	
	if 		(delta.x - 1.5) > 0 then
		text = "Var 1 - 1"
		entity.teleport({
			entity.position.x - box.speed, 
			entity.position.y})
	elseif 	(delta.x + 1.5) < 0 then
		text = "Var 1 - 2"
		entity.teleport({
			entity.position.x + box.speed, 
			entity.position.y})
		else
		text = "Var 1 - 3"
	-- do nothing
	end

	if 		(delta.y - 1.5) > 0 then
		text = "Var 2 - 1"
		entity.teleport({
			entity.position.x , 
			entity.position.y - box.speed})
	elseif 	(delta.y + 1.5) < 0 then
		text = "Var 2 - 2"
		entity.teleport({
			entity.position.x, 
			entity.position.y + box.speed})
	else
		text = "Var 2 - 3"
	-- do nothing
	end


	for _, box in pairs(global.Boxes) do
		if event.tick % 120 == 0 then
			game.players[1].print("Tick " .. event.tick .. " x:" .. delta.x .. " y:" .. delta.y .. " " .. text)
		end
	end
end

-- ================== follow =================
function followTo(entity, ename, etype)
	
	if ename or etype then 
		-- do nothing
		else etype = etype or "player"
		end
	local boxPosition = entity.position
	local radius = 15
	local followedEntities = {}

	if ename and not etype then 
	followedEntities = game.surfaces[1].find_entities_filtered{name = ename, area = GetBoundingBox(boxPosition, radius)} end
	if etype and not ename then
	followedEntities = game.surfaces[1].find_entities_filtered{type = etype, area = GetBoundingBox(boxPosition, radius)} end
	if etype and ename then
	followedEntities = game.surfaces[1].find_entities_filtered{name = ename, type = etype, area = GetBoundingBox(boxPosition, radius)} end
	
	
	if #followedEntities < 1 then
		return false
	end
	
	
	
	return FindNearestEntity(entity, followedEntities)
end



-- ================== onBuildHandler =================
function onBuildHandler(event)
	if not global.Boxes then global.Boxes = {} end
	local entity = event.created_entity
	if 	entity.name == "slow-box" then
		table.insert(global.Boxes, NewStats(entity))
	end
end

-- ================== NewStats =================
function NewStats (entity)
	local NewBox = {
		name = entity.name,
		--position = entity.position,
		entity = entity,
		mustWait = 2*60, -- in ticks
		speed = 0.0625,
		direction = nil,
		energyRadius = 5,
		}
	return NewBox
end


