require "monorail"

--script.on_init(function() On_Load() end)
--script.on_load(function() On_Load() end)
--script.on_event(defines.events.on_init, function() On_Load() end)
--script.on_event(defines.events.on_load, function() On_Load() end)
script.on_event(defines.events.on_tick, function() On_Tick() end)

script.on_event(defines.events.on_built_entity, function(event) On_Built(event) end)
script.on_event(defines.events.on_robot_built_entity, function(event) On_Built(event) end)

script.on_event(defines.events.on_preplayer_mined_item, function(event) On_Removed(event) end)
script.on_event(defines.events.on_robot_pre_mined, function(event) On_Removed(event) end)
script.on_event(defines.events.on_entity_died, function(event) On_Removed(event) end)

-----------------------------------------------------------On_Load
function On_Load()
	if not global.boxes then
		global.boxes = {}
	else
		for _, box in pairs(global.boxes) do
			-- Allow it to re-set its metatable.
			box.Onload(box)
		end
	end
end

-----------------------------------------------------------On_Tick
function On_Tick()
	if not global.followers then global.followers = {} end
	
	for _, follow in pairs(global.followers) do
		--follow.ent.teleport({follow.ent.position.x + 1/60, follow.ent.position.y})
		follow:Tick()
	end
end

-----------------------------------------------------------On_Built
function On_Built(event)
	local ent = event.created_entity
	if ent.name == "slow-box" then
		table.insert(global.followers, box.New(ent))
	end
end

-----------------------------------------------------------On_Built
function On_Removed(event)
	local ent = event.entity
	if ent.name == "slow-box" then
		for i, box in pairs(global.followers) do
			if box.entity == ent then
				follow:Delete()
				table.remove(global.followers, i)
				return
			end
		end
	end
end
