data:extend{

	--------------item-----------------

  {
    type = "item",
    name = "arrow-concrete",
    icon = "__base__/graphics/icons/hazard-concrete.png",
    flags = {"goes-to-main-inventory"},
    subgroup = "terrain",
    order = "b[concrete]-b[hazard]",
    stack_size = 100,
    place_as_tile =
    {
      result = "arrow-up",
      condition_size = 1,
      condition = { "water-tile" }
    }
  },
  
	--------------recipe-----------------

  
	{
    type = "recipe",
    name = "arrow-concrete",
    energy_required = 1,
    enabled = true,
    --category = "crafting-with-fluid",
    ingredients =
    {
      {"iron-plate", 1},
    },
    result= "arrow-concrete",
    result_count = 10
  },

	--------------entity-----------------
	--------------- up  -----------------
	{
      type = "tile",
      name = "arrow-up",
      needs_correction = false,
      next_direction = "arrow-right",
      minable = {hardness = 0.2, mining_time = 0.5, result = "hazard-concrete"},
      mined_sound = { filename = "__base__/sound/deconstruct-bricks.ogg" },
      collision_mask = {"ground-tile"},
      walking_speed_modifier = 1.4,
      layer = 61,
      decorative_removal_probability = 0.9,
      variants = {
        main = {
          {
            -- picture = "__base__/graphics/terrain/hazard-concrete-right/hazard-concrete-right1.png",
			picture = "__Running-box__/graphics/arrows.png",
            count = 1,
            size = 1,
			
			width = 32,
			height = 32,
			frame_count = 1,
			-- x = 32
          },
        },
		side =
		  {
			picture = "__Running-box__/graphics/side.png",
			count = 1
		  },
		 inner_corner =
		  {
			picture = "__Running-box__/graphics/inner.png",
			count = 1,
		  },
		outer_corner =
		  {
			picture = "__Running-box__/graphics/outer.png",
			count = 1
		  },
      },
      walking_sound = {
        {
          filename = "__base__/sound/walking/concrete-01.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-02.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-03.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-04.ogg",
          volume = 1.2
        }
      },
      map_color={r=0.5, g=0.5, b=0},
      ageing=0,
      vehicle_friction_modifier = concrete_vehicle_speed_modifier
    },

	--------------- right  -----------------
	{
      type = "tile",
      name = "arrow-right",
      needs_correction = false,
      next_direction = "arrow-down",
      minable = {hardness = 0.2, mining_time = 0.5, result = "hazard-concrete"},
      mined_sound = { filename = "__base__/sound/deconstruct-bricks.ogg" },
      collision_mask = {"ground-tile"},
      walking_speed_modifier = 1.4,
      layer = 61,
      decorative_removal_probability = 0.9,
      variants = {
        main = {
          {
            -- picture = "__base__/graphics/terrain/hazard-concrete-right/hazard-concrete-right1.png",
			picture = "__Running-box__/graphics/arrows.png",
            count = 1,
            size = 1,
			
			width = 40,
			height = 40,
			frame_count = 1,
			x = 32
          },
        },
		side =
		  {
			picture = "__Running-box__/graphics/side.png",
			count = 1
		  },
		inner_corner =
		  {
			picture = "__Running-box__/graphics/inner.png",
			count = 1
		  },
		outer_corner =
		  {
			picture = "__Running-box__/graphics/outer.png",
			count = 1
		  },
      },
      walking_sound = {
        {
          filename = "__base__/sound/walking/concrete-01.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-02.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-03.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-04.ogg",
          volume = 1.2
        }
      },
      map_color={r=0.5, g=0.5, b=0},
      ageing=0,
      vehicle_friction_modifier = concrete_vehicle_speed_modifier
    },
	
	--------------- down  -----------------
	{
      type = "tile",
      name = "arrow-down",
      needs_correction = false,
      next_direction = "arrow-left",
      minable = {hardness = 0.2, mining_time = 0.5, result = "hazard-concrete"},
      mined_sound = { filename = "__base__/sound/deconstruct-bricks.ogg" },
      collision_mask = {"ground-tile"},
      walking_speed_modifier = 1.4,
      layer = 61,
      decorative_removal_probability = 0.9,
      variants = {
        main = {
          {
            -- picture = "__base__/graphics/terrain/hazard-concrete-right/hazard-concrete-right1.png",
			picture = "__Running-box__/graphics/arrows.png",
            count = 1,
            size = 1,
			
			width = 40,
			height = 40,
			frame_count = 1,
			x = 64
          },
        },
		side =
		  {
			picture = "__Running-box__/graphics/side.png",
			count = 1
		  },
		inner_corner =
		  {
			picture = "__Running-box__/graphics/inner.png",
			count = 1
		  },
		outer_corner =
		  {
			picture = "__Running-box__/graphics/outer.png",
			count = 1
		  },
      },
      walking_sound = {
        {
          filename = "__base__/sound/walking/concrete-01.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-02.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-03.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-04.ogg",
          volume = 1.2
        }
      },
      map_color={r=0.5, g=0.5, b=0},
      ageing=0,
      vehicle_friction_modifier = concrete_vehicle_speed_modifier
    },
	
		--------------- down  -----------------
	{
      type = "tile",
      name = "arrow-left",
      needs_correction = false,
      next_direction = "arrow-up",
      minable = {hardness = 0.2, mining_time = 0.5, result = "hazard-concrete"},
      mined_sound = { filename = "__base__/sound/deconstruct-bricks.ogg" },
      collision_mask = {"ground-tile"},
      walking_speed_modifier = 1.4,
      layer = 61,
      decorative_removal_probability = 0.9,
      variants = {
        main = {
          {
            -- picture = "__base__/graphics/terrain/hazard-concrete-right/hazard-concrete-right1.png",
			picture = "__Running-box__/graphics/arrows.png",
            count = 1,
            size = 1,
			
			width = 40,
			height = 40,
			frame_count = 1,
			x = 96
          },
        },
		side =
		  {
			picture = "__Running-box__/graphics/side.png",
			count = 1
		  },
		inner_corner =
		  {
			picture = "__Running-box__/graphics/inner.png",
			count = 1
		  },
		outer_corner =
		  {
			picture = "__Running-box__/graphics/outer.png",
			count = 1
		  },
      },
      walking_sound = {
        {
          filename = "__base__/sound/walking/concrete-01.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-02.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-03.ogg",
          volume = 1.2
        },
        {
          filename = "__base__/sound/walking/concrete-04.ogg",
          volume = 1.2
        }
      },
      map_color={r=0.5, g=0.5, b=0},
      ageing=0,
      vehicle_friction_modifier = concrete_vehicle_speed_modifier
    },
	
	
	
}
